package com.huimv.farm.damsubsidy.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.huimv.farm.damsubsidy.common.utils.PageUtils;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.entity.BaseFarmerTypeInfo;
import com.huimv.farm.damsubsidy.service.IBaseFarmerTypeInfoService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-05-19
 */
@RestController
@CrossOrigin
@RequestMapping("/base-farmer-type-info")
public class BaseFarmerTypeInfoController {
    @Resource
    private IBaseFarmerTypeInfoService baseFarmerTypeInfoService;

    @PostMapping("/addType")
    public Result addType(@RequestBody Map map){
        String typeName = (String) map.get("typeName");
        Integer farmerType = (Integer) map.get("farmerType");
        Integer animalType = (Integer) map.get("animalType");
        String rewardMoney = (String) map.get("rewardMoney");
        BaseFarmerTypeInfo farmerTypeInfo = baseFarmerTypeInfoService.getOne(new QueryWrapper<BaseFarmerTypeInfo>().eq("farmer_type", farmerType).eq("animal_type", animalType));
        if (ObjectUtil.isNotEmpty(farmerTypeInfo)){
            return new Result(10001,"类别已存在！",false);
        }
        BaseFarmerTypeInfo baseFarmerTypeInfo = new BaseFarmerTypeInfo();
        baseFarmerTypeInfo.setTypeName(typeName);
        baseFarmerTypeInfo.setFarmerType(farmerType);
        baseFarmerTypeInfo.setAnimalType(animalType);
        baseFarmerTypeInfo.setRewardMoney(BigDecimal.valueOf(Double.parseDouble(rewardMoney)));
        baseFarmerTypeInfoService.save(baseFarmerTypeInfo);
        return Result.SUCCESS();
    }

    @PostMapping("/listType")
    public Result listType(@RequestBody Map map){
        String farmerType =map.get("farmerType").toString();
        String animalType =map.get("animalType").toString();
        QueryWrapper<BaseFarmerTypeInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(!ObjectUtil.isEmpty(farmerType),"farmer_type",farmerType).eq(!ObjectUtil.isEmpty(animalType),"animal_type",animalType);
        return new Result(ResultCode.SUCCESS,baseFarmerTypeInfoService.page(PageUtils.getPage(map),queryWrapper));
    }

    @PostMapping("/deleteType")
    public Result deleteType(@RequestBody Map map){
        Integer id = (Integer) map.get("id");
        if (baseFarmerTypeInfoService.removeById(id)) {
            return Result.SUCCESS();
        }else {
            return Result.ERROR();
        }
    }

    @PostMapping("/updateType")
    public Result updateType(@RequestBody Map map){
        Integer id = (Integer) map.get("id");
        String typeName = (String) map.get("typeName");
        Integer farmerType = (Integer) map.get("farmerType");
        Integer animalType = (Integer) map.get("animalType");
        String Money = (String) map.get("rewardMoney");
        BigDecimal rewardMoney = BigDecimal.valueOf(Double.parseDouble(Money));
        BaseFarmerTypeInfo farmerTypeInfo = baseFarmerTypeInfoService.getOne(new QueryWrapper<BaseFarmerTypeInfo>().eq("farmer_type", farmerType).eq("animal_type", animalType).ne("id",id));
        if (ObjectUtil.isNotEmpty(farmerTypeInfo)){
            return new Result(10001,"类别已存在！",false);
        }
        BaseFarmerTypeInfo editFarmerTypeInfo = baseFarmerTypeInfoService.getById(id);
        editFarmerTypeInfo.setTypeName(typeName);
        editFarmerTypeInfo.setAnimalType(animalType);
        editFarmerTypeInfo.setFarmerType(farmerType);
        editFarmerTypeInfo.setRewardMoney(rewardMoney);
//        写锁
//        lock.writeLock().lock();
//        try{
//            baseFarmerTypeInfoService.updateById(editFarmerTypeInfo);
//        }finally {
//            lock.writeLock().unlock();
//        }
        if (baseFarmerTypeInfoService.updateById(editFarmerTypeInfo)) {
            return Result.SUCCESS();
        }else {
            return Result.ERROR();
        }
    }

    @PostMapping("/getRewardMoney")
    public Result getRewardMoney(@RequestBody Map map){
        String rewardNum = (String) map.get("rewardNum");
        Integer farmerType = (Integer) map.get("farmerType");
        Integer animalType = (Integer) map.get("animalType");
        BaseFarmerTypeInfo baseFarmerTypeInfo = baseFarmerTypeInfoService.getOne(new QueryWrapper<BaseFarmerTypeInfo>().eq("farmer_type", farmerType).eq("animal_type", animalType));
        if (ObjectUtil.isEmpty(baseFarmerTypeInfo)){
            return new Result(10001,"奖补类型不存在",false);
        }
        return new Result(ResultCode.SUCCESS,baseFarmerTypeInfo.getRewardMoney().multiply(BigDecimal.valueOf(Double.parseDouble(rewardNum))));
    }

}
